/* profileConf.js - API library for Profile configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT10,mvb  written. 
*/

function profileConfValidate ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtProfName,Please enter valid Profile Name.";
    txtFieldIdArr[1] = "txtSSID,Please enter SSID for the profile.";
    txtFieldIdArr[2] = "txtWPAPasswd,Please enter WPA Password.";
    txtFieldIdArr[3] = "txtWepKey1,Please enter WEP key.";
    txtFieldIdArr[4] = "txtWepKey2,Please enter WEP key.";
    txtFieldIdArr[5] = "txtWepKey3,Please enter WEP key.";
    txtFieldIdArr[6] = "txtWepKey4,Please enter WEP key.";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;
        
    var txtFieldIdArry = new Array ();
    txtFieldIdArry[0] = "txtProfName,Please enter valid Profile Name.";
    txtFieldIdArry[1] = "txtSSID,Please enter SSID for the profile.";    
    if (isProblemCharArrayCheck(txtFieldIdArry) == false)
        return false;
    
    var txtFieldIdAr = new Array ();
    txtFieldIdAr[0] = "txtWPAPasswd,Please enter WPA Password.";
    txtFieldIdAr[1] = "txtWepPsk,Please enter Wep Passphrase.";
    if (isProblemCharArrayCheck2 (txtFieldIdAr) == false)
         return false;

    if (fieldLengthCheck ('txtSSID', 1, 32, "SSID length cannot be more that 32 characters") == false)
        return false;
    if (fieldLengthCheck ('txtWPAPasswd', 8, 64, "WPA password should be at least 8 charactes long.") == false)
        return false;
                
    if (wepKeyCheck() == false)
        {
            return false;
        }
    var nwMode = document.getElementById("hdNwMode").value;
    var puren = document.getElementById("hdPuren").value;
    var selSecObj = document.getElementById("selSecurityOpt");
    if(selSecObj != null && !selSecObj.disabled)
        {
        var sec = comboSelectedValueGet("selSecurityOpt");
        var selEncType = comboSelectedValueGet("selEncType");
        if(sec == "WEP" || (sec == "WPA" && selEncType == "TKIP"))
            {
            if(nwMode.indexOf('na') != -1 || nwMode.indexOf('ng') != -1)
                {
                var mode = "";
                if(nwMode.indexOf('ng') != -1)
                    mode = "NG";
                if(nwMode.indexOf('na') != -1)
                    mode = "NA";
                if(puren == "1")
                    mode = "N only";
                if(sec == "WEP")
                    {
                    var errStr = " WEP not supported in " + mode + ". Please change the radio setting to configure the AP in WEP security mode";
                    }
                else
                    {
                    var errStr = " WPA/TKIP encryption not supported in " + mode + ". Please change the radio setting to configure the AP in WPA/TKIP security mode";
                    }
                alert(errStr);
                return false;
                }
            }
        }            
    return true;
    }
function wepKeyCheck()
    {
    var selSecObj = document.getElementById("selSecurityOpt");
    if(selSecObj != null && !selSecObj.disabled)
        {
        var sec = comboSelectedValueGet("selSecurityOpt");
        if(sec == "WEP")
            {
            var wepKeyLength = parseInt(comboSelectedValueGet("selWepEncrMethod"),10);
            var asciiLen = 5;
            var hexLen = 10;
            if(wepKeyLength == 64) 
                {
                    asciiLen = 5;
                    hexLen = 10;
                }
            else
                {
                    asciiLen = 13;
                    hexLen = 26;
                }
            for(var i = 1; i <= 4; i++)
            {
                var wepKey = document.getElementById('txtWepKey' + i);
                if(wepKey && !wepKey.disabled)
                    {
                        if(wepKey.value.length != asciiLen && wepKey.value.length != hexLen)
                            {
                                alert("Invalid WEP Key Length: Key Length should be " + asciiLen + " for ASCII Key and " + hexLen + " for Hex Key");
                                return false;
                            }
                            var isAscii = true
                            var isHex = true
                            for (var idx = 0; idx < wepKey.value.length; idx++)
                            {
                                var exceptionChars = '"\''
                                var charCode = wepKey.value.charCodeAt(idx)
                                if (!((charCode >= 97 && charCode <= 122) ||
                                      (charCode >= 65 && charCode <= 90) ||
                                      (charCode >= 48 && charCode <= 57) ||
                                       charCode != exceptionChars.charCodeAt(0) ||
                                       charCode != exceptionChars.charCodeAt(1)))
                                     {
                                         isAscii = false;
                                         break;
                                     }
                                if (!((charCode >= 97 && charCode <= 102) ||
                                      (charCode >= 65 && charCode <= 70) ||
                                      (charCode >= 48 && charCode <= 57)))
                                     {
                                         isHex = false;
                                         break;
                                     }
                            }
                            if(isAscii && !(isHex) && wepKey.value.length != asciiLen)
                                {
                                alert("Invalid WEP Key Length: Key Length should be "+ asciiLen + " for ASCII Key");
                                return false;
                                }
                            if(!isHex && wepKey.value.length == hexLen)
                                {
                                alert("Invalid WEP Key Length: Key Length should be "+ hexLen + " for Hex Key");
                                return false;
                                }
                    }
            }
        }
    }    
}
