/* vpn_wizard.js - API library for vpn wizard configuration */

/* Copyright 2010 - 2013 TeamF1, Inc. */

/*
modification history 
------------------------
01b,11-Mar-11,vsr added subnet validate method call in vpnWizValidate() fun
01a,7-OCT-10,mvb  written. 
*/

function vpnWizValidate ()
    {
    /*
    vpn client policy should not be allowed to be configured for Ipv6
    */    
	var selValue = radioCheckedValueGet ('vpnConfig.Peer');
	var ipVersionValue = document.getElementById('selIPType').value;

    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtVPWizName,Please enter a name for the VPN connection being configured";
    txtFieldIdArr[1] = "txtVPWizPsk,Please enter a pre-shared key to be used for the VPN connection";
    if (selValue && (parseInt (selValue, 10) == 0))
        txtFieldIdArr[2] = "txtVPWizRmtIp,Please enter the remote node's IP address or internet name";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    
    var txtFieldArray = new Array ();
    txtFieldArray[0] = "txtVPWizName,";
    txtFieldArray[1] = "txtVPWizPsk,";
    
	if(isProblemCharArrayCheck(txtFieldArray) == false)
		return false;
		
    var txtFieldArrayP = new Array ();
    txtFieldArrayP[0] = "txtVPWizPsk,";
    if(isProblemCharSpArrayCheck(txtFieldArrayP,"\\") == false)
        return false;
         
    var result = false;
    result = fieldLengthCheck ('txtVPWizPsk', 8, 49,
                               'Invalid pre-shared key: Please enter key with length between 8 - 49 characters');
    if (result == false)
        return false;
    var flagg = ipaddrTypeGet ();    
    if (parseInt (selValue, 10) == 0 )
        {        
        if(flagg == 2)
            {
			if(ipv6Validate ('vpnPolicyRemoteLanIPAddress', false, true, '') == false)
			    return false;
			if (numericValueRangeCheck (document.getElementById('rmtLclPreLen'), '', '', 1, 128, true, '', '') == false)
            return false;
		    }
		else
		    {
	        if(flagg == 0 || flagg == 1)
	            {
	            if(ipv4Validate('vpnPolicyRemoteLanIPAddress', 'NID', false, true, 'Invalid IP address', 'for octet ', true) == false)
                    return false;
		        if (ipv4Validate('vpnPolicyRemoteLanIPMask', 'SNM', false, true,'Invalid Subnet Mask', 'for octate ', true) == false)
		            return false;				    
			    if (subnetValidate ('vpnPolicyRemoteLanIPAddress', 'vpnPolicyRemoteLanIPMask') == false)
			    	return false;
			    }
			}
       }
    
    /*Check for Remote WAN IP and Local WAN IP should not be same */
    if(flagg == 2)
        {
        if(ipv6FormatCheck('txtVPWizRmtIp') == true)
            {
	        if(ipv6Validate ('txtVPWizRmtIp', false, true, '') == false)
			    return false;
			}
		if(ipv6FormatCheck('txtVPIkeLId') == true)
		    {   
			if(ipv6Validate ('txtVPIkeLId', false, true, '') == false)
			    return false;
			}

	    var rmtWanIpObj = document.getElementById('txtVPWizRmtIp');
	    var lclWanIpObj = document.getElementById('txtVPIkeLId');
	    var rmtWanIpVal = rmtWanIpObj.value;
	    var lclWanIpVal = lclWanIpObj.value;
	    if(rmtWanIpVal != '' && lclWanIpVal != '')
	        {
	        if(rmtWanIpVal == lclWanIpVal)
	            {
	            alert("Local and Remote Tunnel End Points shouldn't be same");
	            rmtWanIpObj.focus();
	            return false;
	            }
            }
        }
    else
        {
	    if(flagg = 0 || flagg == 1)
	        {
		    var remoteWanIpObj = document.getElementById('txtVPWizRmtIp');
		    var localWanIpObj = document.getElementById('txtVPIkeLId');
		    if(ipV4FormatCheck(remoteWanIpObj.value) == true && ipV4FormatCheck(localWanIpObj.value) == true)
		        {
		        var remoteWanIp = getIPInt1('txtVPWizRmtIp');
		        var localWanIp = getIPInt1('txtVPIkeLId');
		        if(document.getElementById('txtVPIkeLId').value != '0.0.0.0')
		            {
		            if(remoteWanIp == localWanIp)
		                {
		                alert("Local and Remote Tunnel End Points shouldn't be same");
		                remoteWanIpObj.focus();
		                return false;
		                }
                    if(selInterfaceSubnetCheck () == false)
                        return false;
		            }
		        }
		     else
		        {
	            var remoteWanIp = document.getElementById('txtVPWizRmtIp').value;
		        var localWanIp = document.getElementById('txtVPIkeLId').value;		        
		            if(remoteWanIp == localWanIp)
		                {
		                alert("Local and Remote Tunnel End Points shouldn't be same");
		                remoteWanIpObj.focus();
		                return false;
		                }

		        }
	        }
	    }
	    
    /*Lan subnet checking start*/
    if(flagg = 0 || flagg == 1)
        { 
	    var ipAddrObj = document.getElementById ('vpnPolicyRemoteLanIPAddress');
	    if (ipAddrObj && ipAddrObj.disabled) return true;
	    /*Begin:Subnet Checking for LAN*/
	    if(ipAddrObj && !ipAddrObj.disabled)
	        {
	        var i = 0;
	        var remoteLanIp = getIPInt1('vpnPolicyRemoteLanIPAddress');
	        var remoteLanIpObj = document.getElementById('vpnPolicyRemoteLanIPAddress');
	        var numObj = document.getElementById('hdNum');
	        var numObjVal = parseInt(numObj.value,10);
	        var intIP = "";
	        var intIpMask = "";
	        var flag = 0;
	        if(numObj)
	            {
	            while (i <= numObjVal)
	                {
	                i= i + 1;
	                intIPId = "hdIpAddr"+i;
	                intIPMaskId = "hdSnet"+i;
	                if(document.getElementById(intIPId))
	                    {
	                    var intIp = getIPInt1(intIPId);
	                    var intIpMask = getIPInt1(intIPMaskId);
	                    if(document.getElementById(intIPId).value != '0.0.0.0' && document.getElementById(intIPMaskId).value != '0.0.0.0')
	                        {
	                        if(!isInSubnet(remoteLanIp, intIp, intIpMask) == false)
	                            {
	                            var errorstr = "Remote LAN IP Address should not be in LAN/VLAN subnet.";
	                            alert (errorstr);
	                            return false;
	                            }
	                        }
	                    }
	                }
	            }          
	        }
	    }
    /*Lan subnet checking End*/    
     if(parseInt(ipVersionValue,10) == 10)
        {        
        if((maxCountCheck ('hdIkeCount6', 125, 'tblErrMsg') == false) || (maxCountCheck ('hdCount6', 125, 'tblErrMsg') == false))
           return false;
        }
    else
        {
        if((maxCountCheck ('hdIkeCount', 125, 'tblErrMsg') == false) || (maxCountCheck ('hdCount', 125, 'tblErrMsg') == false))
           return false;
        }	    
    return true;
    }
function vpnWizardFinishEnable (statusFlag)
	{
	var btObj = document.getElementById ('btVpnWizardFinish');
	if (!btObj) return;
	if (!statusFlag)
		{
		btObj.disabled = true;
		btObj.className = "b0_dis";
		}
	else
		{
		btObj.disabled = false;
		btObj.className = "b00";
		}
	}
function wanDefaultsSet ()
	{
	var locIdObj = document.getElementById ('txtVPIkeLId');
	var selIPTypeObj = document.getElementById('selIPType');
	var protocolVerVal = 2
	if(!(selIPTypeObj.disabled))
	    protocolVerVal = parseInt(document.getElementById("selIPType").value, 10);
	else
	    protocolVerVal = 2	
    if (!locIdObj)
        return;
	var selValue = radioCheckedValueGet ('vpnConfig.Peer');
	if (selValue == "1")
        {
    	var hdLocId = document.getElementById ('hdLocId');
	    var hdRmtId = document.getElementById ('hdRmtId');
		var locIdObj = document.getElementById ('txtVPIkeLId');
		if (!locIdObj) return;
		var rmtIdObj = document.getElementById ('txtVPWizRmtIp');
		if (!rmtIdObj) return;
		var locIdentArr = hdLocId.value.split (".");
		if (!locIdentArr || locIdentArr.length != 2)
			{
			locIdObj.value = hdLocId.value;
			rmtIdObj.value = hdRmtId.value;
			return;
			}
		var remIdentArr = hdRmtId.value.split (".");
		if (!remIdentArr || remIdentArr.length != 2)
			{
			locIdObj.value = hdLocId.value;
			rmtIdObj.value = hdRmtId.value;
			return;
			}
		var obj = document.getElementById ('selLocGw');
		switch (parseInt (obj.value, 10))
			{
			case 3:	/* WAN4 */
			    locIdObj.value = locIdentArr[0] + "4." + locIdentArr[1];
			    rmtIdObj.value = remIdentArr[0] + "4." + remIdentArr[1];
				break;
			case 2:	/* WAN3 */
			    locIdObj.value = locIdentArr[0] + "3." + locIdentArr[1];
			    rmtIdObj.value = remIdentArr[0] + "3." + remIdentArr[1];
				break;
			case 1:	/* WAN2 */
			    locIdObj.value = locIdentArr[0] + "2." + locIdentArr[1];
			    rmtIdObj.value = remIdentArr[0] + "2." + remIdentArr[1];
				break;
			case 0:	/* WAN1 */
			default:
			    locIdObj.value = locIdentArr[0] + "1." + locIdentArr[1];
			    rmtIdObj.value = remIdentArr[0] + "1." + remIdentArr[1];
				break;
			}
		}
	else
        gateWaySetupCheck ();

	return;
	}
function gateWaySetup ()
	{
	fieldStateChangeWr ('' , '', 'txtVPWizName txtVPWizPsk vpnPolicyRemoteLanIPAddress vpnPolicyRemoteLanIPMask', '');
	selIPTypeCheck ();
    document.getElementById('tdRemId').innerHTML = "What is the Remote WAN's IP Address or Internet Name?"
	document.getElementById('tdLocId').innerHTML = "What is the Local WAN's IP Address or Internet Name?"
    radGroupFuncSet ('hdWan1DdnsState', wanDefaultsSet);
	wanDefaultsSet ();
	var rmtIdObj = document.getElementById ('txtVPWizRmtIp');
	if (!rmtIdObj) return;
    rmtIdObj.value = "";
	}
function clientIpsecHostSetup ()
	{
	fieldStateChangeWr ('vpnPolicyRemoteLanIPAddress vpnPolicyRemoteLanIPMask' , '', 'txtVPWizName txtVPWizPsk', '');
	selIPTypeCheck ();
	document.getElementById('tdRemId').innerHTML = "What is the Remote Identifier Information?"
	document.getElementById('tdLocId').innerHTML = "What is the Local Identifier Information?"
    radGroupFuncSet ('hdWan1DdnsState');
	var locIdObj = document.getElementById ('txtVPIkeLId');
	if (!locIdObj) return;
    locIdObj.value = document.getElementById('hdLocId').value;
	var rmtIdObj = document.getElementById ('txtVPWizRmtIp');
	if (!rmtIdObj) return;
    rmtIdObj.value = document.getElementById('hdRmtId').value;
	}
function vpnWizardInit ()
	{
	updateWAN ();
	rollOverCheck ();
	toggleWrapper();
	var hdIPModeObj = document.getElementById('ipModeType');
	if(hdIPModeObj && hdIPModeObj.value != '')
	    {
	    if(hdIPModeObj.value == 3)
	        fieldStateChangeWr ('rmtLclPreLen' , '', 'selIpv6', '');
	    else{
	        fieldStateChangeWr ('selIpv6 rmtLclPreLen' , '', '', '');
	        document.getElementById('selIpv4').checked = true;
	        }
	    }
	var selValue = radioCheckedValueGet ('vpnConfig.Peer');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Gateway */
			gateWaySetup ();
			break;
		case 1:	/* VPN Client */
			clientIpsecHostSetup ();
			break;
		}
	}

function ipaddrTypeGet ()
    {
    var selIPTypeObj = document.getElementById('selIPType');
    var flag = 0;
    if(selIPTypeObj && !(selIPTypeObj.disabled))
        {
        var selTypeVal = selIPTypeObj.value;
        if(parseInt(selTypeVal, 10) == 10)
            flag = 2;
        else
            flag = 1;
        }
    else
        {flag = 0;}
    return flag;
    }

function rollOverCheck ()
	{
	depFieldCheck ('chkRollOver', true, '', '', 'wan', '');
	depFieldCheck ('chkRollOver', false, 'wan', '', '', '');
	}
	
function deleteOptions (selObj)
	{
	while(selObj.options.length != 0)
		selObj.options[0]=null;
	}

function updateWAN ()
	{
	var primary = document.getElementById('selLocGw');
	if (!primary ) return;
	var secondary = document.getElementById('wan');
	if (!secondary ) return;
	deleteOptions (secondary)
	for (idx = 0, i = 0; i < primary.options.length; i++)
		{
		if (primary.options[i].value != primary.value)
			secondary.options[idx++] = new Option(primary.options[i].text, primary.options[i].value, false, false);
		}
	}
	
function selIPTypeCheck ()
    {
    var selIPTypeObj = document.getElementById('selIPType');
    var radioVal = radioCheckedValueGet ('vpnConfig.Peer');
    if(selIPTypeObj && !(selIPTypeObj.disabled))
        {
        var selTypeVal = selIPTypeObj.value;
        if(parseInt(selTypeVal, 10) == 10)
           {
            showAndHideFields ('tripv4Subnet', 'trIpv6Length','','','','');
            if(radioVal == 1)
                fieldStateChangeWr ('vpnPolicyRemoteLanIPAddress vpnPolicyRemoteLanIPMask rmtLclPreLen' , '', '', '');
            else
                fieldStateChangeWr ('vpnPolicyRemoteLanIPMask' , '', 'rmtLclPreLen', '');
            }
        else
           {
            showAndHideFields ('trIpv6Length', 'tripv4Subnet','','','','');
            if(radioVal == 1)
                fieldStateChangeWr ('rmtLclPreLen vpnPolicyRemoteLanIPMask' , '', '', '');
            else
                fieldStateChangeWr ('rmtLclPreLen' , '', 'vpnPolicyRemoteLanIPMask', '');
           }
        }
    }    

function onTabCheck 
     (
     objId, /*objId = ip text filed ID*/
     objType, /*objType = type of IP - IP /SM,*/
     error /*error = error message*/
     )
    {
    var errMsg = error;
    var selcIPType = document.getElementById('selIPType').value;
    if(!(document.getElementById('selIPType').disabled) && parseInt(selcIPType, 10) == 10)
        {
        if (ipv6Validate (objId, false, true, '') == false)
	        return false;
        }
    else
        {
        if(ipv4Validate(objId, objType, false, true, errMsg, 'for octet ', true) == false)
            return false;
        }
    return true;    
    }
    
/****************************************************************************
Function: toggleWrapper
Purpose: wrapper function, which sets Address family of IP Address
params : N/A
Returns: N/A
*/

function toggleWrapper ()
    {
    var radioValue = radioCheckedValueGet ('ipv4_ipv6');
    var addressFamilyObj = document.getElementById ('selIPType');  
    if( addressFamilyObj)
       {
           addressFamilyObj.value = radioValue;           
       }    
    }

/*This is internally using in wanDefaultSet function*/
function gateWaySetupCheck ()
    {
    var locIdObj = document.getElementById ('txtVPIkeLId');
    var hdWan1StateObj = document.getElementById ('hdWan1DdnsState');
    var hdWan2StateObj = document.getElementById ('hdWan2DdnsState');
   // var hdWan3StateObj = document.getElementById ('hdWan3DdnsState');
   // var hdWan4StateObj = document.getElementById ('hdWan4DdnsState');
    var selIPTypeObj = document.getElementById('selIPType');

    var protocolVerVal = 2
    if(!(selIPTypeObj.disabled))
        protocolVerVal = parseInt(document.getElementById("selIPType").value, 10);
    
    var selObj = document.getElementById ('selLocGw');    
    switch (parseInt (selObj.value, 10))
       {
        case 3: /* WAN4 */
            if(hdWan4StateObj.value == 1)
                 {
                 if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan4Fqdn').value;
                 else
                     locIdObj.value = document.getElementById('hdWan4IPIpv6').value;
                 }
            else
                {
                if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan4Id').value;
                 else
                     locIdObj.value = document.getElementById('hdWan4IPIpv6').value;
                }
            break;
        case 2: /* WAN3 */
            if(hdWan3StateObj.value == 1)
                 {
                 if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan3Fqdn').value;
                 else
                     locIdObj.value = document.getElementById('hdWan3IPIpv6').value;
                 }
            else
                {
                if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan3Id').value;
                 else
                     locIdObj.value = document.getElementById('hdWan3IPIpv6').value;
                }
            break;
        case 1: /* WAN2 */
            if(hdWan2StateObj.value == 1)
                 {
                 if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan2Fqdn').value;
                 else
                     locIdObj.value = document.getElementById('hdWan2IPIpv6').value;
                 }
            else
                {
                if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan2Id').value;
                 else
                     locIdObj.value = document.getElementById('hdWan2IPIpv6').value;
                }
            break;
        case 0: /* WAN1 */
        default:
            if(hdWan1StateObj.value == 1)
                 {
                 if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan1Fqdn').value;
                 else
                     locIdObj.value = document.getElementById('hdWan1IPIpv6').value;
                 }
            else
                {
                if(protocolVerVal == 2)
                     locIdObj.value = document.getElementById('hdWan1Id').value;
                 else
                     locIdObj.value = document.getElementById('hdWan1IPIpv6').value;
                   }
            break;
        }
    }

function selInterfaceSubnetCheck ()
    {
    var selLocGwVal = comboSelectedValueGet ('selLocGw');
    var remoteWanIp = getIPInt1('txtVPWizRmtIp');
    var remoteWanIpObj = document.getElementById('txtVPWizRmtIp');
    var errorstr = "Remote WAN IP Address should not be same as selected local WAN Interface IP.";

    switch(parseInt(selLocGwVal, 10))
        {
        case 1: /*WAN2*/
            var hdWan2IdObj = document.getElementById('hdWan2Id');
            if(hdWan2IdObj && hdWan2IdObj.value != '0.0.0.0')
                {
                if(remoteWanIpObj.value == hdWan2IdObj.value)
                    {
                    alert (errorstr);
                    remoteWanIpObj.focus ();
                    return false;
                    }
                }
             break;
        case 2: /*WAN3*/
            var hdWan3IdObj = document.getElementById('hdWan3Id');
            if(hdWan3IdObj && hdWan3IdObj.value != '0.0.0.0')
                {
                if(remoteWanIpObj.value == hdWan3IdObj.value)
                    {
                    alert (errorstr);
                    remoteWanIpObj.focus ();
                    return false;
                    }
                }
            break;
        case 3: /*WAN4*/
            var hdWan4IdObj = document.getElementById('hdWan4Id');
            if(hdWan4IdObj && hdWan4IdObj.value != '0.0.0.0')
                {
                if(remoteWanIpObj.value == hdWan4IdObj.value)
                    {
                    alert (errorstr);
                    remoteWanIpObj.focus ();
                    return false;
                    }
                }
            break;
        case 0: /*WAN1*/
        default:
            var hdWan1IdObj = document.getElementById('hdWan1Id');
            if(hdWan1IdObj && hdWan1IdObj.value != '0.0.0.0')
                {
                if(remoteWanIpObj.value == hdWan1IdObj.value)
                    {
                    alert (errorstr);
                    remoteWanIpObj.focus ();
                    return false;
                    }
                }
            break;
        }
    return true;
    }
